import shlex
import subprocess


class Execute():
    def __init__(self) -> None:
        self.process = None

    def __call__(self, command: str) -> str:
        args = shlex.split(command)
        self.process = subprocess.Popen(args)

    def close(self):
        if self.process:
            try:
                self.process.kill()
                self.process = None
            except Exception:
                pass

    def __del__(self):
        self.close()
