# 型号
* None


## 描述
支持 Xavier TinyRPCX 通信协议。


## 厂家
* None

## 类名
* TinyRPCX
### 参数
* 仪器名称：字符型，仪器的名称
* 设置：字符型，TinyRPCX客户端的设置信息，包括连接的IP地址与端口号，格式是 “IP地址:端口号”
* 命令结束符：字符型，由于TinyRPCX命令无需结束符，所以该字段只是为了与其它连接方式保持一致而预留的字段，无需填写。
### 例子
```
rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
```

## call(command)
### 调用
### 接口描述
通过TinyRPCX协议远程调用Xavier上的接口。
### 参数
* 命令： 字符型，Xavier上发布出来的TinyRPCX接口。
### 返回值
* 任何类型
### 例子
```
rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
print(rpcx.call('server.all_methods()'))
```

## relay_switch(test_point)
### 继电器切换
### 接口描述
根据定义的网表切换对应的继电器，网表定义在controlbit.json文件中。
### 参数
* 测试点: 列表, 每个元素都是定义在controlbit.json文件中的名称。
### 返回值
* 布尔型: True是切换成功, False是切换失败。
### 例子
```
>>> rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
print(rpcx.relay_switch(['POWER_ON']))
```

## switch(duts)
### 切换通道
### 接口描述
切换MadagascarA的通道，具体的通道由MadagascarA定义，固定管理通道"mgnt"。
### 参数
* 名称: 字符型, 与定义在MadagascarA中的通道名称对应。
### 返回值
* None
### 例子
```
>>> rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
print(rpcx.switch("mgnt"))
```

