# Model
* None


## Description
Support Xavier TinyRPCX protocol.


## Vendor
* None

## Class Name
* TinyRPCX
### Parameters
* partno: str, Device PartNo.
* setting: str, RPCX connect setting. Format is "ip".
* CRLF: str, Reserve.
### Examples
```
rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
```

## call(command)
### Function Description
Call remote method via tinyrpcx protocal.
### Parameters
* command: str, rpcx command.
### Returns
* Any
### Examples
```
rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
print(rpcx.call('server.all_methods()'))
```

## relay_switch(test_point)
### Function Description
Switch the state of the bit according to the network label defined in the controlbit.json file.
### Parameters
* test_point: list, defined in controlbit.json.
### Returns
* Boolen: True is success, False is fail.
### Examples
```
>>> rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
print(rpcx.relay_switch(['POWER_ON']))
```

## switch(name)
### Function Description
Switch to MadagascarA channel, specific channel defined by MadagascarA, management channel named "mgnt".
### Parameters
* name: str, Corresponds to the channel name defined in MadagascarA.
### Returns
* None
### Examples
```
>>> rpcx = TinyRPCX(partno="Xavier-001-007A", setting="169.254.1.32")
print(rpcx.relay_switch("mgnt"))
```
