# 型号
* None


## 描述
支持 Visa 通信协议。


## 厂家
* None

## 类名
* Visa
### 参数
* 仪器名称：字符型，仪器的名称
* 设置：字符型，Visa配置信息，格式是 “资源名称”
* 命令结束符：字符型，与仪器通信时的指令结束符。
### 例子
```
visa = Visa(partno="IT8812C", setting='TCPIP0::169.254.1.32::7801::SOCKET', CRLF='\r\n')
```

## write(command)
### 发送数据
### 接口描述
使用Visa发送字符串数据
### 参数
* 命令： 字符型，Visa指令
### 返回值
* None
### 例子
```
visa = Visa(partno="IT8812C", setting='TCPIP0::169.254.1.32::7801::SOCKET', CRLF='\r\n')
visa.write('*IDN?')
```

## read(length)
### 接收串口数据
### 接口描述
接收Visa的数据并按照字符串的格式返回
### 参数
* 长度：整型，接收的数据长度
### 返回值
* 字符型
### 例子
```
visa = Visa(partno="IT8812C", setting='TCPIP0::169.254.1.32::7801::SOCKET', CRLF='\r\n')
visa.write('*IDN?')
print(visa.read())
```

## query(command)
### 发送并接收数据
### 接口描述
发送Visa指令并接收返回结果
### 参数
* 命令： 字符型，Visa指令
### 返回值
* 字符型
### 例子
```
visa = Visa(partno="IT8812C", setting='TCPIP0::169.254.1.32::7801::SOCKET', CRLF='\r\n')
visa.query('*IDN?')
```