# Archon用户手册

---
<!-- TOC -->
- [Archon用户手册](#archon用户手册)
  - [1 概述](#1-概述)
  - [2 安装&执行](#2-安装执行)
  - [3 快速开始](#3-快速开始)
    - [3.1 创建项目](#31-创建项目)
    - [3.2 配置仪器信息](#32-配置仪器信息)
    - [3.3 编写测试用例](#33-编写测试用例)
    - [3.4 编写测试计划](#34-编写测试计划)
    - [3.5 项目调试](#35-项目调试)
    - [3.6 项目发布](#36-项目发布)
  - [4 针点配置](#4-针点配置)
    - [4.1 视图](#41-视图)
    - [4.2 针点配置文件路径](#42-针点配置文件路径)
    - [4.3 编写针点配置文件](#43-编写针点配置文件)
      - [4.3.1 background说明](#431-background说明)
        - [4.3.1.1 制作针点背景图](#4311-制作针点背景图)
        - [4.3.1.2 从原理图导出背景图](#4312-从原理图导出背景图)
      - [4.3.2 defaultConfig说明](#432-defaultconfig说明)
      - [4.3.3 bit_symname_map说明](#433-bit_symname_map说明)
      - [4.3.4 points](#434-points)
        - [4.3.2.1 针点只有BIT位的情况](#4321-针点只有bit位的情况)
        - [4.3.2.2 针点包含功能点和BIT位的情况](#4322-针点包含功能点和bit位的情况)
        - [4.3.2.3 针点包含功能点嵌套的情况](#4323-针点包含功能点嵌套的情况)
    - [4.4 编写针点表格文件](#44-编写针点表格文件)
    - [4.5 导入针点信息](#45-导入针点信息)
    - [4.6 配置针点信息](#46-配置针点信息)
      - [4.6.1 选择需要配置的针点](#461-选择需要配置的针点)
      - [4.6.2 配置的针点](#462-配置的针点)
        - [4.6.2.1 配置BIT的位](#4621-配置bit的位)
        - [4.6.2.2 配置的功能点](#4622-配置的功能点)
    - [4.7 导出针点信息](#47-导出针点信息)
    - [4.7 恢复默认](#47-恢复默认)
    <!-- /TOC -->

---

## 1 概述

Archon是一款面向硬件的全场景测试管理工具软件，适用于硬件研发阶段的调试与验证、NPI阶段的调试、生产阶段的自动化测试等场景，致力于降低测试工程师开发、管理和运行测试用例的难度。Archon以低代码的方式开发测试用例和编排测试计划，支持通过Python来实现更复杂的测试用例，支持通过开发插件的方式来扩展系统功能。Archon支持在界面上实时查看测试结果数据，同时还提供了报表模板导出所需数据，用户可以自定义报表模板来满足特定的数据导出需求。

![archon_platform](./resource/cn/v2.3/Archon_Platform.png)

如上图所示，Archon主要由UI和Core两部分组成，通过插件进行功能扩展。其中UI提供测试用例编写、测试计划编排、测试结果显示、用户权限管理和数据报表导出等图形用户接口。Core的主要功能包括测试用例的调度运行、测试结果数据的收集、插件管理和通信链路的维护。插件主要用于仪器接口、设备驱动和北向数据系统对接等功能扩展。

## 2 安装&执行

Archon安装文件是zip格式的压缩文件，比如Archon-windows-V2.3.zip。解压Archon-windows-V2.3.zip文件，进入**Archon-windows-V2.2/ui**目录，双击Archon.exe即可运行Archon程序。Archon需要注册才能使用，Archon启动后如果软件未注册会出现下图提示，请把图中红色方框所示的机器码提供给我司人员获取注册码。拿到注册码后填入输入框内，点击**确定**即可。

![3_license](./resource/cn/v2.3/archon_no_license.png)

## 3 快速开始

本文档以控制仪器测量一个电压为例子讲述如何连接仪器, 如何编写、调试测试用例和测试计划。

### 3.1 创建项目

3.1.1 点击左侧导航栏中的**项目管理**按钮，然后点击**新建项目**按钮。

![new_project_1](./resource/cn/v2.3/project_guide.png)

3.1.2 填写项目信息，点击**OK**。

![new_project_2](./resource/cn/v2.3/new_project_config.png)

- **项目名称**: 项目名称
- **版本(可选)**: 项目版本
- **描述(可选)**: 项目详细描述信息。
- **报表格式(可选)**: 自动生成测试报告的类型，Archon Single Report表示每次测试生成一份报告，Archon Total Report表示多次测试（可选择）生成一份报告。
- **循环模式**：配置选项包括：只循环测试部分和循环全部（初始化-测试-结束）；只循环测试部分是指配置循环次数后，指执行初始化部分的测试用例一次，然后循环执行多次（次数是所配置的循环次数）后再执行结束的测试用例部分；循环全部是指初始化、测试和结束部分的测试用例均按顺序执行多次。
- **测试策略**: 多通道（线程）运行模式，Serial表示表示多通道串行执行，Paraller表示多个通道并行执行.

### 3.2 配置仪器信息

3.2.1 在配置前先把仪器连接到Archon运行的PC，然后点击项目管理左侧导航栏中的**仪器管理**按钮（下图箭头1所示）或者**仪器管理状态**按钮（下图箭头2所示），进入仪器管理界面。
![add_device_1](./resource/cn/v2.3/project_instruments.png)

3.2.2 点击的**添加**按钮（如上图箭头3所示）新增仪器，新增仪器界面如下图所示。

![add_device_2](./resource/cn/v2.3/Add_instrument_Blank.png)

- **名称**: 仪器名称
- **厂家**: 仪器生产厂家，支持下拉列表选择以及手动输入
- **型号**: 仪器型号，支持下拉列表选择以及手动输入
- **序列号**: 仪器序列号
- **通道**: 测试通道，测试通道可理解为测试线程，Archon可以支持多个通道同时运行。
- **连接方式**: 仪器连接方式，支持以下连接方式：
  - VISA: Virtual Instrument Software Architecture连接接口
  - SERIAL: 串口
  - TcpClient: TCP客户端接口
  - TcpServer: TCP服务端接口
  - SSH: Secure Shell接口
  - Arbiter: SmartGiant控制器接口
  - Plugin: python插件接口，通过该接口将python插件实例化供测试用例中调用。
- **命令终止符**: 命令终止符是用来表示命令结束的控制字符，默认值为：\r\n。
- **检测命令**: 匹配命令，默认为*IDN?
- **检测字段**: 匹配字符串，该配置与匹配命令配合一起用于仪器的自动适配。匹配字符串默认为"<厂家>,<型号>"，比如Agilent Technologies,33519B. 仪器自动适配是指Archon打开项目后，自动扫描所有与Archon连接的仪器并向其仪器发送匹配命令，当匹配命令返回的信息与匹配字符串列表其中一个相同时，则认为该仪器匹配正确并自动连接。

3.2.3 在新增仪器界面填写仪器名称、选择生产厂家和型号，连接方式选择VISA（如图箭头1所示），在VISA ID选择仪器的连接ID（如下图箭头2所示），其他配置采用默认值。
![add_device_3](./resource/cn/v2.3/project_add_device_visa.png)

3.2.4 在新增仪器界面填写仪器名称、选择生产厂家:SmartGiant和型号:Arbiter，填写IP地址。
![add_device_4](./resource/cn/v2.3/project_add_arbiter.png)

3.2.5 按照3.2.3的方法添加仪器名称为Power的VISA仪器。

3.2.6 添加仪器后，点击**保存**按钮保存配置。仪器列表中可以看到仪器的连接状态。
![add_device_5](./resource/cn/v2.3/project_instruments_ok.png)

3.2.7 保存完成后，仪器列表中的"针点"按钮（如下图箭头1所示），配置Arbiter控制器的针点信息。
![add_device_6](./resource/cn/v2.3/project_set_arbiter_bit.png)
![add_device_6](./resource/cn/v2.3/project_set_arbiter_bit2.png)


### 3.3 编写测试用例

3.3.1 点击项目管理界面左侧导航栏中的**测试用例**按钮，进入**测试用例**界面，点击新增按钮（如下图箭头1所示），archon创建一个命名为**测试用例1**的测试用例。

![add_testcase_1](./resource/cn/v2.3/project_testcase_blank.png)

3.3.2 选中测试用例**测试用例1**，点击右键，选择**重命名**，将测试用例修改为合适的名称**set_input_voltage**。

![add_testcase_2](./resource/cn/v2.3/project_testcase_menu.png)

3.3.3 使用vscode或sublime编辑Python，输入以下代码，然后保存文件为**utility.py**。

```py
def strtofloat(str):
    return float(str)
```

3.3.4 点击导入按钮（如下图箭头1所示），选择步骤3.3.3创建的python文件**utility.py**，点击**打开**。

![tc_rename](./resource/cn/v2.3/project_testcase_import_tpy.png)

![tc_rename](./resource/cn/v2.3/project_testcase_tpy.png)

3.3.5 选中测试用例**set_input_voltage**，在右侧的表格中输入代码。

![tc_rename](./resource/cn/v2.3/project_testcase_device_list.png)
![tc_rename](./resource/cn/v2.3/project_testcase_function_list.png)
![tc_rename](./resource/cn/v2.3/project_testcase_addon_function_list.png)
![tc_rename](./resource/cn/v2.3/project_testcase_addon_params_list.png)
![tc_rename](./resource/cn/v2.3/project_testcase_info.png)

表格说明：

- 设备: 需要调用的设备名称，与设备管理的保持一致。
- 功能: 设备支持的功能。
- 参数: 功能参数。
- 返回值名称: 测试用例返回的结果的别名，方便后续测试用例进行调用。
- 返回值单位: 测试结果对应的单位。
- 下偏: 最小值，用来和result做对比。
- 上偏: 最大值，用来和result做对比。
- 超时: 测试用例的超时时间，单位是毫秒，可以不填，默认是一直等待

代码说明：

- 行1: 设置仪器Power电压为22V（Params为SCPI指令，请参考仪器的用户手册）
- 行2: 延迟100ms（archon为内置仪器）。
- 行3: 读取Power当前的电压，当前电压值保存在input_vol。
- 行4：将input_vol（科学计数法）转换为数字，archon暂不支持转换，所以需要通过addon调用外部python接口来实现。

3.3.6 重复步骤1、2、5，创建测试用例:**get_eload_current**。

![tc_rename](./resource/cn/v2.3/project_testcase_info_1.png)

3.3.7 重复步骤1、2、5，创建测试用例:**get_eload_voltage**。

![tc_rename](./resource/cn/v2.3/project_testcase_info_2.png)

3.3.8 点击**保存**保存测试用例。

### 3.4 编写测试计划

3.4.1 点击项目管理界面左侧导航栏中的**测试计划**按钮，进入测试计划界面，点击新增按钮（如下图箭头1所示）。

![add_testplan_1](./resource/cn/v2.3/project_testplan.png)

3.4.2 在新建测试计划界面，修改测试计划名称以及绑定通道，点击**确定**。

![add_testplan_2](./resource/cn/v2.3/project_testplan_new.png)

3.4.3 每个测试计划包含3个文件，分别为初始化、测试和结束。
- 初始化：填写测试开始前需要初始化的测试用例。
- 测试：填写具体测试业务的测试用例。
- 结束：填写测试结束后需要执行的测试用例，只要测试结束都会执行该部分的用例。
  测试结束是指以下三种情况：
  1. 用户主动点击**停止**按钮来停止执行测试计划
  2. 勾选**运行错误时停止测试**，当初始化和测试部分任意一个测试用例返回Fail均会停止测试，并执行结束部分。
  3. 测试部分运行结束。

选中**测试计划演示**下的**测试**文件（实际项目请根据项目业务需求在不同的部分填写相应的测试用例，演示项目无需配置初始化部分），在右侧表格的点击右键，选择**插入**新增一行。

![add_testplan_2](./resource/cn/v2.3/project_testplan_edit.png)

3.4.4 双击**用例名**列中的空白行，在下拉列表中选择测试用例:**set_input_voltage**，点击**保存**。

![add_testplan_3](./resource/cn/v2.3/project_testplan_edit_2.png)

### 3.5 项目调试

**测试计划**界面划分为5部分：

- 运行调试按钮，如图红色方框1所示
- 运行数据查看，如图红色方框2所示
- 运行参数配置，如图红色方框3所示
- 运行数据统计，如图红色方框4所示
- 日志查看，如图红色方框5所示

![debug](./resource/cn/v2.3/project_testplan_viewer.png)

3.5.1 调试按钮如下图：

![debug_1](./resource/cn/v2.3/project_testplan_debug_button.png)

- 运行/暂停: 运行/暂停测试计划，当允许状态处于暂停或者停止时，运行按钮使能，当运行处于运行状态时，暂停按钮使能。
- 停止: 停止执行，当运行状态处于运行或者暂停时，该按钮使能。
- 单步: 单步执行，当运行状态处于暂停时，该按钮使能。

3.5.2 设置断点：点击测试计划表格最左侧（下图红色方框部分），可设置当前行为断点，红色点表示该行设置为断点，测试计划运行到该行时自动暂停运行。

![debug_2](./resource/cn/v2.3/project_testplan_breakpoint.png)

3.5.3 数据查看：如下图所示，点击箭头1按钮，显示该行测试用例的详细信息；箭头2显示该测试用例测试通过状态，箭头3显示测试用例每行执行的结果和通过状态。

![debug_3](./resource/cn/v2.3/project_testplan_table_info.png)

3.5.4 运行配置：

![debug_4](./resource/cn/v2.3/project_testplan_run_settings.png)

- 运行错误时停止测试: 勾选后，运行过程中测试用例结果返回Fail则自动停止，反之将一直运行到循环结束。
- 循环执行: 循环运行，勾选后可配置循环运行的次数。

3.5.5 统计信息：

![debug_5](./resource/cn/v2.3/project_testplan_run_totol.png)

统计Archon启动以来当前项目测试计划运行成功和失败的次数，点击如上图箭头1所示的按钮可清除计数。
- PASS: 测试计划运行成功的次数。
- FAIL：测试计划运行失败的次数。

3.5.6 通道信息：
统计当前通道（测试计划）所执行的时间以及测试计划成功和失败次数。

![debug_5](./resource/cn/v2.3/project_testplan_channel_totol.png)
- 上图箭头1表示执行返回成功的测试用例个数。
- 上图箭头2表示执行返回失败的测试用例个数。
- 上图箭头3表示测试计划执行的时间。
- 上图箭头4表示测试计划循环执行的次数。
- 上图箭头5表示测试计划循环执行的总时间。

3.5.7 日志查看：

![debug_6](./resource/cn/v2.3/project_testplan_log.png)

- 时间: 日志时间
- 类型: 日志级别，分为info, warnning, error
- 通道: 运行的通道
- 用例名称: 运行的用例，2-1表示测试计划第二个测试用例的第1行代码运行返回的日志，2表示测试计划的第2个用例运行完返回的日志。
- 结果: 测试结果
- 详细: 详细日志，单击弹出详细日志窗口。

![debug_7](./resource/cn/v2.3/project_testplan_log_detail.png)

3.5.8 如果发现Archon的Bug，请描述Bug详细信息并将以下路径的日志文件作为附件反馈给我们，我们会尽快解决。

- Core日志路径: $Archon安装目录/core/log/
- UI日志路径: $Archon安装目录/ui/log/

### 3.6 项目发布

3.6.1 调试完成后，需要将项目发布才能在生产环境中使用。在项目管理界面中点击**发布**(如图箭头1所示)进入项目发布界面，填写项目版本，点击如图箭头2所示按钮(如图箭头2所示)，弹出选择路径，填写发布名称，完成后点击**发布**按钮(如图箭头3所示)。

![publish_1](./resource/cn/v2.3/project_publish.png)

3.6.2 项目发布后需要绑定相应的产品才能在生产测试中使用。在主界面中点击**产品管理**(如图箭头1所示)进入产品管理界面，点击**添加**按钮(如图箭头2所示)。

![publish_2](./resource/cn/v2.3/products_add.png)

3.6.3 填写产品型号，然后点击测试包的如图箭头所示按钮进入测试包导入界面。

![publish_3](./resource/cn/v2.3/products_add_import.png)

3.6.4 测试包导入界面，点击的**导入**按钮(如图箭头1所示)，选择刚才发布的项目包，点击**确定**按钮(如图箭头2所示)。

![publish_4](./resource/cn/v2.3/products_add_import_packages.png)

3.6.5 在主界面中点击**生产测试**(如图箭头1所示)进入生产测试界面，选择测试产品(如图箭头2所示)和测试包(如图箭头3所示)，如图箭头5在测试过程显示当前产品的SN，点击**开始测试**(如图箭头6所示)。测试开始后，通过图中箭头7查看测试进度以及是否存在错误，点击详细视图(如图箭头9所示)可切换视图模式，通过表格形式查看测试计划执行的情况。图中箭头8所指的统计是指测试成功和失败的测试，绿色为成功次数，红色为失败测试。图中箭头4所指的测试参数分别表示：
- 老化测试，勾选后需要填写产品批次，当所填写的产品批次存在老化记录才使能开始测试按钮。
- 自动测试，勾选后点击开始测试会无限循环运行测试计划，直到用户点击停止测试。
- 自动生成报表，勾选后每次执行测试计划完成后自动在所选择的测试报告目录生成测试报表。
- 错误时停止，勾选后执行测试计划过程中存在错误的测试用例则停止运行。

![publish_5](./resource/cn/v2.3/ATS_Run.png)

## 4 针点配置
针点配置是我司型号为：Arbiter和MadagascarA的仪器的特有配置项，针点配置是指将测试功能所需要切换一系列BIT位设置成一个集合，在编写测试用例时调用切换指令填写该集合名称即可，极大的方便用户实现BIT位切换。

### 4.1 视图
针点配置有两种针点视图：图形视图以及表格视图
- 图形视图：
  ![point_1](./resource/cn/v2.3/point_main_canvas.png)
  
- 表格视图
![point_2](./resource/cn/v2.3/point_main_table.png)


1. Archon默认为图形视图并且针点配置与其背景图形是匹配的，当你的项目使用的背景图不一样，需要手动编辑图形文件以及编写针点配置文件描述针点信息。
2. 如果采用表格视图，则编写针点配置文件描述针点信息以及对应的表格csv文件。

### 4.2 针点配置文件路径
针点视图显示方式是由项目的针点配置文件决定，针点配置文件路径为：\$项目路径/controlbit/[\$第一个通道名称]\$仪器名称
- 项目路径是指用户创建的项目或者打开已有项目的路径。
- 第一个通道名称是指通道配置的第一个通道的名称，默认为通道1。
- 仪器名称是指用户配置的仪器名称。

### 4.3 编写针点配置文件

项目的针点配置文件结构如下：
```js
{
  "configs": {
    "background": {},
    "defaultConfig":{},
    "bit_symname_map":{},
    "points": [],
    "zoom":1
  }
}
```
#### 4.3.1 background说明
backgroud结构如下：
```js
{
  "x": 0,
  "y": 0,
  "type": "image",
  "backgroundImg": "TP_MAP.png",
  "tableFile": ""
}
```
- type:针点视图的类型，image表示图形视图，table表示表格视图，如果不填写则默认为image。
- x,y:图形视图的图片坐标，默认为0。
- backgroundImg:图形视图图片的文件名或者图片base64格式的数据，图片转换base64工具地址：https://tool.chinaz.com/tools/imgtobase，如下图所示。
![point_3](./resource/cn/v2.3/point_image_to_base64.png)  
- tableFile:表格的配置文件名。

##### 4.3.1.1 制作针点背景图
自行制作的关键在于背景图的制作，在制作背景图时需要考虑针点大小及布局。
如下示例：
![point_4](./resource/cn/v2.3/point_edit_image.png)
- 规划方格的大小为250px,方格内放置8个针点，每个针点半径为8px(实际大小为16\*16)，每个针点间隔14px，也就是说每个针点实际占用空间为16+14=30px。8个针点实际占用空间为8\*30=240px，则得出方格内边距为(250-240)/2 = 5px。
- 第一方格的位置为x=80px，y=80px，得出第一方格内的第一个针点位置为：</br>
  80(方格X) + 5(内边距) + 7 (间隔14px/2) + 8(中心坐标) = 100px </br>
  80(方格Y) + 5(内边距) + 7 (间隔14px/2) + 8(中心坐标) = 100px </br>
- 以此推得，第一个方格的第一排第二列针点位置为：</br>
  X：100(第一列位置) + 8(第一列半径) + 14 (间隔) + 8(第二列半径) = 130px </br>
  Y：100px

##### 4.3.1.2 从原理图导出背景图
在实际项目的原理图中，应该包括了底图的大小及每个针点的名称、大小及位置信息，底图可以通过选择或屏蔽图层进行导出。
- 导出底图，调整底图至一个合适的大小，如下图所示：
![point_4](./resource/cn/v2.3/point_import_image.png)
- 用户需要进行针点大小及位置的确认，由于原理图中的单位和图片像素单位间存在差异，在导出底图后，需要对比图片像素与原理图实际大小从而得出转换比例。
![point_4](./resource/cn/v2.3/point_image_size_change.png)
如上图所示，原理图中底图宽3CM，经调整后的背景图为600px。
在此，我们大略得出转换公式为：600(px) = 300(mm) \* 2
通过此公式，可以得出每个针点对应背景图的大小及位置。如原理图中针点大小为8mm，坐标为(10,12)mm，转换后的大小为8\*2=16px,坐标为(20px,24px)



#### 4.3.2 defaultConfig说明
defaultConfig针点图形配置（大小和背景颜色），可选项，对表格视图无效，结构如下：
```js
{
  "defaultConfig" : {
    "height": 8,
    "width": 8,
    "state": [
      {
        "ID": "normal",
        "background": "#909399",
        "opacity": 1
      },
      {
        "ID": "config",
        "background": "#409EFF",
        "opacity": 1
      },
      {
        "ID": "selected",
        "background": "#0F0",
        "opacity": 1
      }
    ]
  },
}
```
- height: 针点长度。
- width: 针点宽度。
- state: 针点状态颜色配置。
- ID表示状态，不能修改，normal表示该针点无配置（没有任何功能点或者BIT位），config有配置（配置有功能点或者BIT位），selected表示选中状态。
- background:针点背景颜色。
- opacity: 预留配置。

#### 4.3.3 bit_symname_map说明
bit_symname_map为可选项，只有background.type为table时有效，用于绘制开关切换的顺序图，结构如下：
- key: 名称
- symname: 开关标号
- dir: 开关方向

```js
{
  "bit_symname_map":{
    "K59,K85(MEAS)": [
        {
            "symname": "K59",
            "dir": "31"
        },
        {
            "symname": "K85",
            "dir": "31"
        }
    ],
    "K59,K85(RST)": [
        {
            "symname": "K59",
            "dir": "31"
        },
        {
            "symname": "K85",
            "dir": "31"
        }
    ],
    ......
  },
  "points":[
    {
      "name": "BT_I2S_DI_TO_SCOPE",
      "description": "BT_I2S_DI_TO_SCOPE MEASUREMEANT",
      "list": [
        {
          "name": "BT_I2S_DI_TO_SCOPE_MEAS",
          "description": "BT_I2S_DI_TO_SCOPE MEASUREMEANT",
          "list": [
            "K59,K85(MEAS)"
          ]
        },
        {
          "name": "BT_I2S_DI_TO_SCOPE_RST",
          "description": "BT_I2S_DI_TO_SCOPERESET",
          "list": [
            "K59,K85(RST)"
          ]
        }
      ]
    },
    {
       "name": "BT_I2S_DO_TO_SCOPE",
       "description": "BT_I2S_DO_TO_SCOPE MEASUREMEANT",
       "list": [
         {
           "name": "K59,K85(MEAS)",
           "description": "K59,K85 MEASUREMEANT",
           "list": [
              "K59,K85(MEAS)"
           ]
         },
         {
           "name": "K59,K85(RST)",
           "description": "K59,K85 RESET",
           "list": [
              "K59,K85(RST)"
           ]
         }
       ]
    },
    {
        "name": "BT_REG_ON_TO_DM01",
        "description": "BT_REG_ON__CONN_TO_DM01 MEASUREMEANT",
        "list": [
          {

            "name": "BT_REG",
            "description": "BT_REG_ON__CONN_TO_DM01 MEASUREMEANT",
            "list": [
              "K59,K85(MEAS)"
            ]
          },
          {
            "name": "BT_RST",
            "description": "BT_REG_ON__CONN_TO_DM01RESET",
            "list": [
              "K59,K85(RST)"
            ]
          }
        ]
    }
  ],
}
```
![point_3](./resource/cn/v2.3/point_table_bitmap.png)
![point_4](./resource/cn/v2.3/point_table_bitmap_info.png)
如上图所示1的描述是根据针点名称来确定，命名规则为aa_TO_bb，解析后尾aa connect to bb。
如上图所示2的K59和K85是读取bit_symname_map的K59,K85(MEAS)列表组个绘制图形并以symname的值来命名，图中标号3和1则为dir标注的方向。

#### 4.3.4 points
points为针点列表，每个针点可以包括多个功能点和BIT位，格式为：
- name：针点或者功能名称
- description: 针点或者功能描述
- x: 可选项，backgroud.type为image是有效，表示针点的图形圆点x坐标。
- y: 可选项，backgroud.type为image是有效，表示针点的图形圆点y坐标。
- list：功能点或者BIT位列表。建议保留为空，导入到针点管理后在操作界面进行配置。

**功能点：是指多个BIT的组合，功能点支持嵌套，也就是说组合里面可以包括功能点**</br>
**BIT位: 控制器切换的BIT位** 


```js
{
  "name": "WL_HOST_WAKE_CONN_TO_DM01",
  "description": "WL_HOST_WAKE_CONN_TO_DM01 MEASUREMEANT",
  "x": 100,
  "y": 100,
  "list": [
    {
      {
        "name": "U42(MEAS)",
        "description": "U42 MEASUREMEANT",
        "list":[
          {
            "bit2": 0
          }, 
        ]
      },
      {
          "bit4": 0
      },      
    }
  ]
}
```
##### 4.3.2.1 针点只有BIT位的情况

```js
{
  "name": "WL_HOST_WAKE_CONN_TO_DM01",
  "description": "WL_HOST_WAKE_CONN_TO_DM01 MEASUREMEANT",
  "list": [
    {
      {
          "bit4": 0
      },
      {
          "bit3": 0
      },
      {
          "bit2": 0
      },
      {
          "bit1": 1
      }
    }
  ]
}
```

##### 4.3.2.2 针点包含功能点和BIT位的情况
```js
{
  "name": "WL_HOST_WAKE_CONN_TO_DM01",
  "description": "WL_HOST_WAKE_CONN_TO_DM01 MEASUREMEANT",
  "list": [
    {
      {
        "name": "U42(MEAS)",
        "description": "U42 MEASUREMEANT",
        "list":[
          {
            "bit2": 0
          }, 
          {
            "bit3": 0
          }, 
        ]
      },
      {
        "bit4": 0
      },
      {
        "bit5": 1
      },          
    }
  ]
}
```

##### 4.3.2.3 针点包含功能点嵌套的情况
```js
{
  "name": "WL_HOST_WAKE_CONN_TO_DM01",
  "description": "WL_HOST_WAKE_CONN_TO_DM01 MEASUREMEANT",
  "list": [
    {
      {
        "name": "U42(MEAS)",
        "description": "U42 MEASUREMEANT",
        "list":[
          {
            "bit2": 0
          }, 
          {
            "bit3": 0
          }, 
        ]
      },
      {
        "name": "P_GPIO16_TO_DM01_RST",
        "description": "P_GPIO16_TO_DM01RESET",
        "list": [
          {
              "bit52": 0
          },
          {
              "bit37": 0
          },
          "U42(MEAS)",   //引用U42(MEAS)功能点
          {
              "bit38": 0
          },
          {
              "bit53": 0
          }
        ]
      }
      {
        "bit4": 0
      },      
    }
  ]
}
```

### 4.4 编写针点表格文件
可选项，只有background.type为table时需要编写。
表格为csv格式，规则如下：
```csv
aa1, aa2,...,NET,bb1,bb2,NET,bb1,bb2...
```

- NET为固定列，名称固定为NET，不能删除。
- NET中间包含两列，名称可以修改，比如bb1,bb2或者cc1,cc2
- 第一个Net列前面必须有N列（至少有一列），用于表示针点列，当该列的值为PT_SHOW，则表示需要显示（生成）针点，针点的名称为Net的名称+"TO"+该列表格的名称（生成的名称与config.json文件描述的针点名称一致）；为空或其他值则不用显示（生成）针点。
- 第二个Net列后面必须有N列（至少有一列），用于表示针点列，当该列的值为PT_SHOW，则表示需要显示（生成）针点，针点的名称为Net的名称+"TO"+该列表格的名称；为空或其他值则不用显示（生成）针点。

csv例子：
```csv
ZYNQ,SCOPE,DMM,DM01,NET,J1300,J1300,NET,DM01,DMM,SCOPE,ZYNQ
,,,,,1,2,BT_HOST_WAKE_CONN,PT_SHOW,,,
,,,,,3,4,BT_REG_ON_CONN,PT_SHOW,,,
,,,,,5,6,BT_DEV_WAKE_CONN,PT_SHOW,,,
,,,,,7,8,,,,,
PT_SHOW,,,PT_SHOW,SOC_TO_WLAN_PERST_N_CONN,9,10,SOC_TO_BT_UART_TXD_CONN,,,PT_SHOW,
PT_SHOW,PT_SHOW,,,WLAN_TO_SOC_CLKREQ_N_CONN,11,12,SOC_TO_BT_UART_RTS_CONN,,,PT_SHOW,
,,,PT_SHOW,WLAN_TO_SOC_WAKE_N_CONN,13,14,SOC_TO_BT_UART_CTS_CONN,,,PT_SHOW,
,,,,,15,16,SOC_TO_BT_UART_RXD_CONN,,,PT_SHOW,
,,,,,17,18,,,,,
```

效果如图所示：
![point_4](./resource/cn/v2.3/point_table_name_rule.png)

### 4.5 导入针点信息
- 导入图形针点配置：编写完成针点配置完成后，保存为config.json，点击**导入针点信息**（如图中1所示），选择刚才保存的config.json文件，点击**打开**。
![point_4](./resource/cn/v2.3/point_import_config.png)

- 导入图形表格配置：编写完成针点配置完成后，保存为config.json，将针点表格文件保存为，table.csv，然后将config.json和table.csv压缩为config.zip，点击**导入针点信息**（如图中1所示），选择刚才config.zip文件，点击**打开**。

### 4.6 配置针点信息
#### 4.6.1 选择需要配置的针点
- 如图中1所示，选中带配置的针点，进入针点配置。
- 如图中2所示，输入针点名称，查询到针点信息后，如图中3所示，点击**配置**，进入针点配置。
![point_4](./resource/cn/v2.3/point_select_config_point.png)

#### 4.6.2 配置的针点
- 如图中1所示，修改针点名称。
- 如图中2所示，修改针点描述。
- 如图中3所示，点击**添加**，选择需要添加的功能点或者BIT位。
![point_4](./resource/cn/v2.3/point_edit_point.png)

##### 4.6.2.1 配置BIT的位
点击**添加**，选择BIT位后。
- 如图中1所示，修改BIT位的名称。
- 如图中2所示，修改BIT位的值。
![point_4](./resource/cn/v2.3/point_edit_bit.png)

* 引用是指可以引用已配置的功能点。

##### 4.6.2.2 配置的功能点
- 如图中1所示，点击**编辑**，进入功能点配置界面，其界面操作与针点配置一致。
![point_4](./resource/cn/v2.3/point_edit_function.png)


### 4.7 导出针点信息
点击**导出针点信息**，选择导出路径，系统根据图形类型导出不同的配置文件：图形视图导出的是config.json文件，表格视图导出的是config.zip文件。

### 4.7 恢复默认
点击**恢复默认**，则恢复回默认的图形视图的配置。
